/***
 * REXX Communication Control Function Library  Ver.1.9
 *                  copyright 1998-2002, Naga(Kazuo Adachi)
 *                          mailto:nagaw@attglobal.net
 *
 * $Id$
 *
 * $Log$
 */

#ifndef _RXCOMM_H_
#define _RXCOMM_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define INCL_DOSMISC
#define INCL_DOSFILEMGR
#define INCL_DOSERRORS
#define INCL_DOSDEVIOCTL
#define INCL_DOSDEVICES
#define INCL_RXFUNC
#include <os2.h>
#ifndef __EMX__
#include <rexxsaa.h>
#endif

#include "IO_ASYNC.H"


/*--------------------------------------------------------*/
/***
 * REXX Communication Revision Strings.
 */
#define RXCOMM_REVISION         "1.9"


/*--------------------------------------------------------*/
/***
 * REXX Communication CR/LF Convert.
 */
typedef enum
{
    RXCH_NULL = 0,  /* Ignore */
    RXCH_CR   = 1,
    RXCH_LF   = 2,
    RXCH_CRLF = 3,
    RXCH_ORG  = 4   /* Through */

} RXCRLF;


/*--------------------------------------------------------*/
/***
 * REXX Communication Information Structure.
 */
#pragma pack(1)

typedef struct  __rxCommInfo
{
    PSZ     pszName;        /* COM Device Name */
    HFILE   hcmFile;        /* COM Device Handle */

    BOOL    nulStrp;        /* Option values */
    BOOL    sndChar;
    BOOL    rcvChar;
    BOOL    logMode;
    BOOL    binMode;
    RXCRLF  sndRxCR;
    RXCRLF  sndRxLF;
    RXCRLF  rcvRxCR;
    RXCRLF  rcvRxLF;

    PSZ     pszRecv;        /* Recieve Buffer */
    ULONG   maxRecv;
    ULONG   posRecv;

    PSZ     pszSend;        /* Sending Buffer */
    ULONG   maxSend;

    HFILE   logFile;        /* Log File Handle */

} RXCOMM, *PRXCOMM;

#pragma pack()

extern  RXCOMM          rxcInfo;

#define DEF_RECVBUFF    (2048L)
#define DEF_SENDBUFF    (1024L)


/*--------------------------------------------------------*/
/***
 * DCB(Device Control Block) Default Value
 */
#define DCB_WRITETIME   (0x00)
#define DCB_READ_TIME   (0x00)
#define DCB_MODESHAKE   (0x00)
#define DCB_MODE_FLOW   (0x00)
#define DCB_TIME_OUT    (MODE_NOWAIT_READ_TIMEOUT)


/*--------------------------------------------------------*/
/***
 * REXX Communication Write Retry Times.
 */
#define DEF_WRITETRY    (10)

/*--------------------------------------------------------*/
/***
 * REXX Communication Read Sleep TIME.
 */
#define DEF_READWAIT    (10)

/*--------------------------------------------------------*/
/***
 * REXX Communication Read Timeout TIME.
 */
#define DEF_READEXIT    (1000)

/*--------------------------------------------------------*/
/***
 * REXX Communication Break Signal TIME.
 */
#define DEF_SNDBREAK    (500L)


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _RXCOMM_H_ */
